#ifndef GROUP_CMDS_H
#define GROUP_CMDS_H

//    This file is part of MRCI.

//    MRCI is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    MRCI is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with MRCI under the LICENSE.md file. If not, see
//    <http://www.gnu.org/licenses/>.

#include "../common.h"
#include "table_viewer.h"

class ListGroups : public TableViewer
{
    Q_OBJECT

public:

    static QString cmdName();

    explicit ListGroups(QObject *parent = nullptr);
};

//--------------------------------------

class CreateGroup : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit CreateGroup(QObject *parent = nullptr);
};

//--------------------------------------

class RemoveGroup : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RemoveGroup(QObject *parent = nullptr);
};

//--------------------------------------

class TransGroup : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit TransGroup(QObject *parent = nullptr);
};

//-------------------------------------

class SetGroupRank : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit SetGroupRank(QObject *parent = nullptr);
};

//------------------------------------

class RenameGroup : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RenameGroup(QObject *parent = nullptr);
};

#endif // GROUP_CMDS_H
